/**
 * @param {string} command process to run
 * @param {string[]} args commandline arguments
 * @returns {Promise<void>} promise
 */
declare const runCommand: (command: string, args: string[]) => Promise<unknown>;
/**
 * @param {string} packageName name of the package
 * @returns {boolean} is the package installed?
 */
declare const isInstalled: (packageName: string) => boolean;
/**
 * @typedef {Object} CliOption
 * @property {string} name display name
 * @property {string} package npm package name
 * @property {string} binName name of the executable file
 * @property {string} alias shortcut for choice
 * @property {boolean} installed currently installed?
 * @property {string} url homepage
 * @property {string} description description
 */
/** @type {CliOption[]} */
declare const CLIs: {
    name: string;
    package: string;
    binName: string;
    alias: string;
    installed: boolean;
    url: string;
    description: string;
}[];
declare const installedClis: {
    name: string;
    package: string;
    binName: string;
    alias: string;
    installed: boolean;
    url: string;
    description: string;
}[];
