import * as webpack from 'webpack';
import debug = require('debug');
import { DepGraph } from 'dependency-graph';
export declare const MultiCompiler1: MultiCompilerStatic;
export interface MultiCompilerStatic extends webpack.MultiCompiler {
    new (compilers: webpack.Compiler[] | WebpackCompilerMap): webpack.MultiCompiler;
}
export interface WebpackCompilerMap {
    [name: string]: webpack.Compiler;
}
export interface WebpackCompilerCompileFn {
    (callback: (err: Error | null, compilation?: webpack.compilation.Compilation) => void): void;
}
export interface WebpackCompiler2 extends webpack.Compiler {
    _udk: {
        callbacks: ((err?: Error) => void)[];
        dependants: WebpackCompiler2[];
        dependencies: WebpackCompiler2[];
        lastChange?: {
            fileName: string;
            changeTime: number;
        };
        lastError?: Error | null;
        lastStats?: {
            [key: string]: any;
        } | null;
        running: boolean;
        compile: WebpackCompilerCompileFn;
        watch: webpack.Compiler['watch'];
        watchings: webpack.Compiler.Watching[];
    };
    compile: WebpackCompilerCompileFn;
    createCompilation(): webpack.Stats;
}
export declare enum WebpackCompilerStage {
    environment = "environment",
    afterEnvironment = "afterEnvironment",
    entryOption = "entryOption",
    afterPlugins = "afterPlugins",
    afterResolvers = "afterResolvers",
    beforeRun = "beforeRun",
    run = "run",
    watchRun = "watchRun",
    normalModuleFactory = "normalModuleFactory",
    contextModuleFactory = "contextModuleFactory",
    beforeCompile = "beforeCompile",
    compile = "compile",
    thisCompilation = "thisCompilation",
    compilation = "compilation",
    make = "make",
    afterCompile = "afterCompile",
    shouldEmit = "shouldEmit",
    emit = "emit",
    afterEmit = "afterEmit",
    done = "done",
    failed = "failed",
    invalid = "invalid",
    watchClose = "watchClose"
}
export default class MultiCompiler extends MultiCompiler1 {
    _udk: {
        depGraph: DepGraph<WebpackCompiler2>;
        overallOrder: string[];
    };
    constructor(compilers: webpack.Compiler[] | WebpackCompilerMap);
    getCompiler(name: string): {
        compiler: WebpackCompiler2;
        dependants: WebpackCompiler2[];
        dependencies: WebpackCompiler2[];
    };
}
export declare function createDepGraph(nodes: webpack.Compiler[]): DepGraph<WebpackCompiler2>;
export declare function debugCompilerStage(compiler: webpack.Compiler, stage: WebpackCompilerStage): void;
export declare function getCancelledCompilation(compiler: WebpackCompiler2): webpack.compilation.Compilation | undefined;
export declare function getCompiler(compilerName: string, depGraph: DepGraph<WebpackCompiler2>): {
    compiler: WebpackCompiler2;
    dependants: WebpackCompiler2[];
    dependencies: WebpackCompiler2[];
};
export declare function getCompilerDebugger(compiler: string | webpack.Compiler): debug.Debugger;
export declare function holdOnDependencies(compiler: WebpackCompiler2, callback: (err?: Error) => void): void;
export declare function invalidateDependants(compiler: WebpackCompiler2, callback?: (err?: Error) => void): void;
export declare function parseMultiCompilerInput(compilers: webpack.Compiler[] | WebpackCompilerMap): webpack.Compiler[];
export declare function prepareCompiler(compilerName: string, depGraph: DepGraph<WebpackCompiler2>): WebpackCompiler2;
