import * as webpack from 'webpack';
export declare type GetEntryOutputPathFromStatsInput = webpack.Stats | WebpackStatsJson;
export interface GetEntryOutputPathOptions {
    entryName?: string;
    outputPath?: string;
}
export interface WebpackCompilationEntrypoint {
    name: string;
    chunks: WebpackCompilationEntrypointChunk[];
}
export interface WebpackCompilationEntrypointsV3 {
    [name: string]: WebpackCompilationEntrypoint;
}
export interface WebpackCompilationEntrypointsV4 extends Map<string, WebpackCompilationEntrypoint> {
}
export interface WebpackCompilationEntrypointChunk {
    name: string;
    files: string[];
}
export interface WebpackStatsJson {
    assetsByChunkName?: {
        [key: string]: string[];
    };
    assets?: WebpackStatsJsonAsset[];
    chunks?: WebpackStatsJsonChunk[];
    entrypoints?: WebpackStatsJsonEntrypoints;
    [key: string]: any;
}
export interface WebpackStatsJsonAsset {
    name: string;
    chunkNames: string[];
}
export interface WebpackStatsJsonEntrypoints {
    [key: string]: WebpackStatsJsonEntrypoint;
}
export interface WebpackStatsJsonEntrypoint {
    chunks: string[];
}
export interface WebpackStatsJsonChunk {
    id: string;
    files: string[];
    names: string[];
}
export declare function getEntryOutputPathFromStats(stats: GetEntryOutputPathFromStatsInput, entryNameOrOptions?: string | GetEntryOutputPathOptions): string | null;
