/// <reference types="node" />
import Module = require('module');
export interface IModuleStatic {
    _resolveFilename: ModuleFilenameResolver;
}
export declare type ModuleFilenameResolver = (request: string, parent: Module, isMain: boolean, options?: ModuleFilenameResolverOptions | null) => string;
export declare type ModuleFilenameResolverHook = (request: string, parent: Module, isMain: boolean, options: ModuleFilenameResolverOptions | null | undefined, previousResolver: ModuleFilenameResolver) => string;
export interface ModuleFilenameResolverOptions {
    paths?: string[];
}
export interface ModuleRequestAlias {
    fromFile: string;
    replaceRequest: string;
    withRequest: string;
}
export declare type RemoveModuleFilenameResolverHookFn = () => void;
export declare const ModuleStatic: IModuleStatic;
export declare const nativeModuleResolveFilename: ModuleFilenameResolver;
export declare let moduleResolveFilename: ModuleFilenameResolver;
export declare function aliasModuleResolveFilename(alias: ModuleRequestAlias): RemoveModuleFilenameResolverHookFn;
export declare function disableModuleResolveFilenameHook(): void;
export declare function enableModuleResolveFilenameHook(): void;
export declare function hookModuleResolveFilename(hook: ModuleFilenameResolverHook): RemoveModuleFilenameResolverHookFn;
export declare function resolveModuleRequestAlias(alias: ModuleRequestAlias, request: string, parent: Module, isMain: boolean, options: {
    paths: string[];
} | null | undefined, previousResolver: ModuleFilenameResolver): string;
